'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _yup = require('yup');

var _yup2 = _interopRequireDefault(_yup);

var _lodashSet = require('lodash.set');

var _lodashSet2 = _interopRequireDefault(_lodashSet);

var _lodashIsempty = require('lodash.isempty');

var _lodashIsempty2 = _interopRequireDefault(_lodashIsempty);

var _lodashClone = require('lodash.clone');

var _lodashClone2 = _interopRequireDefault(_lodashClone);

var _utils = require('./utils');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

exports['default'] = function (yupOptions) {
  return {
    validate: function validate(data, yupSchema, options, callback) {
      if (data === undefined) data = {};
      if (yupSchema === undefined) yupSchema = _yup2['default'].object().shape({});

      var _this = this;

      if (options === undefined) options = {};

      (0, _invariant2['default'])(typeof callback === 'function', 'yup-validation-strategy is asynchronous, a callback is expected: validate(data, schema, options, callback)');
      var key = options.key;
      var _options$prevErrors = options.prevErrors;
      var prevErrors = _options$prevErrors === undefined ? {} : _options$prevErrors;

      var validationOptions = _extends({
        abortEarly: false,
        stripUnknown: true
      }, yupOptions);
      yupSchema.validate(data, validationOptions, function (yupResult) {
        var errors = _this.collectErrors(yupResult);
        if (key === undefined || key === null || (0, _lodashIsempty2['default'])(errors)) {
          return callback((0, _utils.hydrate)(errors));
        } else {
          return callback((0, _lodashClone2['default'])((0, _lodashSet2['default'])(prevErrors, key, errors[key])));
        }
      });
    },
    collectErrors: function collectErrors(yupResult) {
      if (yupResult !== null) {
        return yupResult.inner.reduce(function (errors, _ref) {
          var path = _ref.path;
          var message = _ref.message;

          return _extends({}, errors, _defineProperty({}, path, [message]));
        }, {});
      } else {
        return {};
      }
    }
  };
};

module.exports = exports['default'];